/*

  ComboboxQueue.h
  Copyright(C) 2008-2015 INASOFT /Ayacy

  ComboboxQueue.lib𗘗p邽߂̃wb_t@C
  RnsfpR{{bNXWXgAgCu
  iREG_MULTI_SZ^̃WXgGgɁA̒li[܂j

*/

#ifndef MYLIB__ISCOMBOBOXQUEUE__
#define MYLIB__ISCOMBOBOXQUEUE__

#ifndef OWN__COMBOBOXQUEUE__
#pragma comment(lib, "ComboboxQueue.lib")
#endif /* OWN__COMBOBOXQUEUE__ */

// NX錾(ANSI)
class ComboboxQueueA {
public:
	ComboboxQueueA() :						// RXgN^
	  szStrings(NULL), hRoot(NULL), strSubkey(NULL), strValue(NULL), hCtrl(NULL), num(0) {}
	~ComboboxQueueA();						// fXgN^
	bool Init(HWND hWnd, int iCtrl, int num, HKEY hRoot, const char *szSubKey, const char *szValue);
	bool Init(HWND hCtrl, int num, HKEY hRoot, const char *szSubkey, const char *szValue);
	bool Add(const char *szText);			// v_E̒ǉiÂ͍̂폜j

private:
	char **szStrings;			// v_E
	HKEY hRoot;					// ֘AtꂽWXgL[̃nh
	char *strSubkey;			// ֘AtꂽWXgL[
	char *strValue;				// ֘AtꂽWXgl
	HWND hCtrl;					// R{{bNX̃Rg[nh
	int  num;					// R{{bNX̃XgɊi[łő吔

	bool register_strings();		// WXgւ̏
};

// NX錾(Unicode)
class ComboboxQueueW {
public:
	ComboboxQueueW() :						// RXgN^
	  szStrings(NULL), hRoot(NULL), strSubkey(NULL), strValue(NULL), hCtrl(NULL), num(0) {}
	~ComboboxQueueW();						// fXgN^
	bool Init(HWND hWnd, int iCtrl, int num, HKEY hRoot, const wchar_t *szSubKey, const wchar_t *szValue);
	bool Init(HWND hCtrl, int num, HKEY hRoot, const wchar_t *szSubkey, const wchar_t *szValue);
	bool Add(const wchar_t *szText);		// v_E̒ǉiÂ͍̂폜j

private:
	wchar_t **szStrings;		// v_E
	HKEY hRoot;					// ֘AtꂽWXgL[̃nh
	wchar_t *strSubkey;			// ֘AtꂽWXgL[
	wchar_t *strValue;			// ֘AtꂽWXgl
	HWND hCtrl;					// R{{bNX̃Rg[nh
	int  num;					// R{{bNX̃XgɊi[łő吔

	bool register_strings();		// WXgւ̏
};

#ifdef _UNICODE
#define ComboboxQueue ComboboxQueueW
#else  /* _UNICODE */
#define ComboboxQueue ComboboxQueueA
#endif /* _UNICODE */

#endif /* MYLIB__ISCOMBOBOXQUEUE__ */
